
Core - Bug # 48336

Status: Rejected Priority: Must have
Author: Frans Saris Category: File Abstraction Layer (FAL)
Created: 2013-05-17 Assigned To:
Updated: 2013-09-10 Due date:
TYPO3 Version: 6.2
PHP Version:
Complexity:
Is Regression: No
Sprint Focus:
Subject: sys_file record doesn't get flagged as delete after deleting a file 
Description

When you delete a file (in BE filelist module) the deleted field in sys_file record doesn't get updated to 1

Related issues:
related to Core - Feature # 48182: File-Indexer doesn't flag missing files as... Closed 2013-05-14
related to Core - Bug # 50363: Fatal error: Call to undefined method TYPO3\CM... Rejected 2013-07-24
related to Core - Bug # 50508: Re-uploading file in backend fails Resolved 2013-07-29
related to Core - Bug # 50531: Deleted state is not persisted in file objects Closed 2013-07-29
related to Core - Task # 50876: Handling of deleted files in FAL New 2013-08-06

Associated revisions
Revision d22cea3b - 2013-07-06 17:12 - Frans Saris

[BUGFIX] sys_file record doesn't get flagged as delete

File is deleted by driver and deleted property of FileObject is set by
ResourceStorage but new state is not persisted.

Update deleted property in updateProperties array in FileObject and
persist change.

Fixes: #48336
Releases: 6.2, 6.1, 6.0
Change-Id: I6cac106dcf89125e0b98b8b12a03c0b3f56d484f
Reviewed-on: https://review.typo3.org/20982
Reviewed-by: Steffen Ritter
Tested-by: Steffen Ritter

Revision 27039510 - 2013-07-06 17:17 - Frans Saris

[BUGFIX] sys_file record doesn't get flagged as delete

File is deleted by driver and deleted property of FileObject is set by
ResourceStorage but new state is not persisted.

Update deleted property in updateProperties array in FileObject and
persist change.
Fixes: #48336
Releases: 6.2, 6.1, 6.0
Change-Id: I6cac106dcf89125e0b98b8b12a03c0b3f56d484f
Reviewed-on: https://review.typo3.org/22024
Reviewed-by: Steffen Ritter
Tested-by: Steffen Ritter

Revision 66e08fe0 - 2013-07-06 17:17 - Frans Saris

[BUGFIX] sys_file record doesn't get flagged as delete

File is deleted by driver and deleted property of FileObject is set by
ResourceStorage but new state is not persisted.

Update deleted property in updateProperties array in FileObject and
persist change.

Fixes: #48336
Releases: 6.2, 6.1, 6.0
Change-Id: I6cac106dcf89125e0b98b8b12a03c0b3f56d484f
Reviewed-on: https://review.typo3.org/22025
Reviewed-by: Steffen Ritter
Tested-by: Steffen Ritter

Revision f3778d8c - 2013-07-06 18:09 - Christian Kuhn

Revert "[BUGFIX] sys_file record doesn't get flagged as delete"

This reverts commit d22cea3b61ffec1931bf5b12dd9cddde5eb28ca1

The patch kills unit tests. We guess there is some incomplete
mocking in Resource tests but are not able to quickly find
the root of it. The patch is reverted for now until the tests
are green again.

Change-Id: I5e7bb6e14187f7179e00b0b00decda644e1c6efe
Resolves: #48336
Releases: 6.2, 6.1, 6.0
Reviewed-on: https://review.typo3.org/22034
Reviewed-by: Christian Kuhn
Tested-by: Christian Kuhn

Revision e1991aec - 2013-07-06 18:14 - Christian Kuhn

Revert "[BUGFIX] sys_file record doesn't get flagged as delete"

This reverts commit 27039510ebf9e456330face27d465863af5d0a0c

The patch kills unit tests. We guess there is some incomplete
mocking in Resource tests but are not able to quickly find
the root of it. The patch is reverted for now until the tests
are green again.

Change-Id: I5e7bb6e14187f7179e00b0b00decda644e1c6efe
Resolves: #48336
Releases: 6.2, 6.1, 6.0
Reviewed-on: https://review.typo3.org/22037
Reviewed-by: Christian Kuhn
Tested-by: Christian Kuhn

Revision 31b29c04 - 2013-07-06 18:16 - Christian Kuhn

Revert "[BUGFIX] sys_file record doesn't get flagged as delete"

This reverts commit 66e08fe0d978ee6ca6ce1c965ae99678a4f0c88b

The patch kills unit tests. We guess there is some incomplete
mocking in Resource tests but are not able to quickly find
the root of it. The patch is reverted for now until the tests
are green again.

Change-Id: I5e7bb6e14187f7179e00b0b00decda644e1c6efe
Resolves: #48336
Releases: 6.2, 6.1, 6.0
Reviewed-on: https://review.typo3.org/22038
Reviewed-by: Christian Kuhn
Tested-by: Christian Kuhn

Revision 18bb6574 - 2013-07-06 22:06 - Steffen Ritter

[BUGFIX] sys_file record doesn't get flagged as delete

File is deleted by driver and deleted property of FileObject is set by
ResourceStorage but new state is not persisted.
Update deleted property in updateProperties array in FileObject and
persist change.

Reintroduced after fixing tests in f3778d8c8cfe93ccdb8cfa.

Change-Id: I0784c84af4bfb8021c648139c2feee577f3e9dc1
Fixes: #48336
Releases: 6.2, 6.1, 6.0
Reviewed-on: https://review.typo3.org/22056
Reviewed-by: Steffen Ritter
Tested-by: Steffen Ritter

Revision 640e4d51 - 2013-07-06 22:44 - Steffen Ritter

[BUGFIX] sys_file record doesn't get flagged as delete
File is deleted by driver and deleted property of FileObject is set by
ResourceStorage but new state is not persisted.
Update deleted property in updateProperties array in FileObject and
persist change.

Reintroduced after fixing tests in 9f081830c3537e286378e406579e914ffc162969.

Change-Id: I0784c84af4bfb8021c648139c2feee577f3e9dc1
Fixes: #48336
Releases: 6.2, 6.1, 6.0
Reviewed-on: https://review.typo3.org/22060
Reviewed-by: Steffen Ritter
Tested-by: Steffen Ritter

Revision f45af2ce - 2013-07-06 22:45 - Steffen Ritter

[BUGFIX] sys_file record doesn't get flagged as delete

File is deleted by driver and deleted property of FileObject is set by
ResourceStorage but new state is not persisted.
Update deleted property in updateProperties array in FileObject and
persist change.

Reintroduced after fixing tests in 836dbc652033e118967eccc0bae2ebbde8637735.

Change-Id: I0784c84af4bfb8021c648139c2feee577f3e9dc1
Fixes: #48336
Releases: 6.2, 6.1, 6.0
Reviewed-on: https://review.typo3.org/22064
Reviewed-by: Steffen Ritter
Tested-by: Steffen Ritter

History
#1 - 2013-05-17 22:58 - Frans Saris

Did just some debugging and found out that $fileObject->deleted is set to TRUE. But the change isn't persisted.

The following 2 changes fixes this.

In \TYPO3\CMS\Core\Resource\ResourceStorage::deleteFile() add:

        // Mark the file object as deleted
        $fileObject->setDeleted();
        $this->updateFile($fileObject);

and change \TYPO3\CMS\Core\Resource\ResourceStorage::updateFile() to:

    protected function updateFile(AbstractFile $file, $identifier = '', $storage = NULL) {
        if ($identifier === '') {
            $identifier = $file->getIdentifier();
        }
        if($file->isDeleted()) {
            $newProperties = array('deleted' => 1);
        } else {
            $fileInfo = $this->driver->getFileInfoByIdentifier($identifier);
            // TODO extend mapping
            $newProperties = array(
                'storage' => $fileInfo['storage'],
                'identifier' => $fileInfo['identifier'],
                'tstamp' => $fileInfo['mtime'],
                'crdate' => $fileInfo['ctime'],
                'mime_type' => $fileInfo['mimetype'],
                'size' => $fileInfo['size'],
                'name' => $fileInfo['name']
            );
        }
        if ($storage !== NULL) {
            $newProperties['storage'] = $storage->getUid();
        }
        $file->updateProperties($newProperties);
        $this->getFileRepository()->update($file);
    }

The last change isn't that nice. would be better the driver returns info about the fact the file is deleted/missing. But at the moment the driver throws an
excpetion. Maybe a try...chatch and in the catch set to $newProperties to deleted?

Or only

In \TYPO3\CMS\Core\Resource\ResourceStorage::deleteFile() add:

        // Mark the file object as deleted
        $fileObject->setDeleted();
        $fileObject->updateProperties(array('deleted' => 1));
        $this->getFileRepository()->update($fileObject);

#2 - 2013-05-22 20:38 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20982

#3 - 2013-05-22 20:52 - Gerrit Code Review
Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20982

#4 - 2013-07-06 17:06 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20982

#5 - 2013-07-06 17:15 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-1 has been pushed to the review server.
It is available at https://review.typo3.org/22024

#6 - 2013-07-06 17:17 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-0 has been pushed to the review server.
It is available at https://review.typo3.org/22025

#7 - 2013-07-06 17:30 - Frans Saris
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:66e08fe0d978ee6ca6ce1c965ae99678a4f0c88b.

#8 - 2013-07-06 18:08 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/22034

#9 - 2013-07-06 18:13 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-1 has been pushed to the review server.
It is available at https://review.typo3.org/22037

#10 - 2013-07-06 18:16 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-0 has been pushed to the review server.
It is available at https://review.typo3.org/22038

#11 - 2013-07-06 18:30 - Christian Kuhn
- Status changed from Under Review to Resolved
Applied in changeset commit:31b29c0418f88fdeb5eea6e0236b5763b4d10598.

#12 - 2013-07-06 22:05 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/22056

#13 - 2013-07-06 22:24 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-1 has been pushed to the review server.
It is available at https://review.typo3.org/22060

#14 - 2013-07-06 22:30 - Steffen Ritter
- Status changed from Under Review to Resolved

Applied in changeset commit:18bb6574966d6fdff944e8fd5f95e9225dae4365.

#15 - 2013-07-06 22:45 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch TYPO3_6-0 has been pushed to the review server.
It is available at https://review.typo3.org/22064

#16 - 2013-07-06 23:30 - Steffen Ritter
- Status changed from Under Review to Resolved

Applied in changeset commit:f45af2ceed02c849c30715892582b68e6aff5e5a.

#17 - 2013-07-29 18:48 - Oliver Hader

Reverted in all branches due to regressions!

#18 - 2013-07-29 23:04 - Chris topher
- Status changed from Resolved to New
- % Done changed from 100 to 0

#19 - 2013-09-03 21:44 - Ernesto Baschny
- Status changed from New to Needs Feedback
- Target version set to 6.2.0
- TYPO3 Version changed from 6.1 to 6.2
Frans, we now have the "missing" flag which is more semantically correct. The "deleted" flag should be dropped as decided in Mainz (#51562). So this
issue here is now also obsolete, right?

#20 - 2013-09-04 13:04 - Frans Saris

Yes this issue is obsolete now.

#21 - 2013-09-10 00:14 - Ernesto Baschny
- Status changed from Needs Feedback to Rejected
- Is Regression set to No
